let arr = [];
let arrTwo = [];
let colors = ['#ffb300', '#f54842', '#335de8', '#28e61e', '#ff82f5'];
let colorsTwo = ['#ffb300', '#f54842', '#335de8', '#28e61e', '#ff82f5'];
//let ovoce = ['Jablka','Jahody','Třešně','Pomeranče','Melouny', 'Paprika', 'Okurka', 'Pomelo'];
let ovoce = ['Jablka','Jahody','Melouny','Pomeranče', 'Třešně','Paprika', 'Okurka', 'Pomelo'];

class Table {
    constructor(_nums, _numsTwo) {
        this.rows = document.querySelectorAll(_nums)
        this.rowsTwo = document.querySelectorAll(_numsTwo)
    }

    randNums(arrX) {
        while (arrX.length < 5) {
            this.rndNum = (Math.floor(Math.random() * 45) + 1) * 4 ;
            if(!arrX.includes(this.rndNum)){
                arrX.push(this.rndNum);
            }             
        }
    }

    addNums() {
        this.randNums(arr);
        this.randNums(arrTwo);
        for (let i = 0; i < arr.length; i++) {
            this.rows[i].innerHTML = arr[i];
            this.rowsTwo[i].innerHTML = arrTwo[i];
        }
    }

    static shuffleArray(arrX) {
        for (let i = arrX.length - 1; i > 0; i--) {
            const j = Math.floor(Math.random() * (i + 1));
            [arrX[i], arrX[j]] = [arrX[j], arrX[i]];
        }
    }
    //smysl to tu nema, ale lze to vyuzit 
    static kontrolujInputy(prvek, co){
        //var prvek = prvek;
        if (co == "cisla") {
            prvek.addEventListener("change", function cis(){
                var hodnoty = document.getElementsByClassName('numerTwo');
                let kontrola = true;
                var tplPole = [];
                for (let i = 0; i < 5; i++) {
                    tplPole.push(hodnoty[i].selectedIndex);
                    if (hodnoty[i][hodnoty[i].selectedIndex].value < 0) {
                        kontrola = false;
                        break;
                    }
                }
                if (kontrola) {
                    let tabTwo = document.querySelector('#tabTwo');         
                    tabTwo.click();               
                    tabTwo.style.display = "inline-block";
                    let klon;
                    for (let i = 0; i < 5; i++) {
                        klon = hodnoty[i].cloneNode(true);
                        hodnoty[i].parentNode.replaceChild(klon, hodnoty[i]);
                        hodnoty[i].selectedIndex = tplPole[i];
                    } 
                }
            });
        }else{
            prvek.addEventListener("change", function oAz() {
                var nazvy = document.getElementsByClassName('lineInputs')
                let kontrola = true;
                var tplPole = [];
                for (let i = 0; i < 5; i++) {
                    tplPole.push(nazvy[i].selectedIndex);
                    if (nazvy[i][nazvy[i].selectedIndex].value < 0) {
                        kontrola = false;
                        break;
                    }
                }
                if (kontrola) {
                    let btnTwo = document.querySelector('#btnTwo');
                    btnTwo.click();
                    btnTwo.style.display = "inline-block";
                    let klon;
                    for (let i = 0; i < 5; i++) {
                        klon = nazvy[i].cloneNode(true);
                        nazvy[i].parentNode.replaceChild(klon, nazvy[i]);
                        nazvy[i].selectedIndex = tplPole[i];
                    } 
                }
            });
        }        
    }
}

class grid{
    constructor(_platno, _width, _height, _gridColor, _gridScale, _padding, arrX){
        this.idPlatna = document.getElementById(_platno);
        this.idPlatna.width = _width;
        this.idPlatna.height = _height;
        this.platno = this.idPlatna.getContext("2d");
        this.gridColor = _gridColor;
        this.gridScale = _gridScale;
        this.padding = _padding;
        this.fruits = {
            "Jablka": arrX[0],
            "Hrušky": arrX[1],
            "Melouny": arrX[2],
            "Pomeranče": arrX[3],
            "Třešně": arrX[4]
        };
    }

    drawLine(platno, startX, startY, endX, endY, color, lineWidth){
        platno.save();
        platno.strokeStyle = color;
        platno.beginPath();
        platno.moveTo(startX,startY);
        platno.lineTo(endX,endY);
        platno.lineWidth = lineWidth;
        platno.stroke();
        platno.restore();
    }

    drawGrid(jo){
        let maxValue = 0;

        if(jo === "JO"){
            this.platno.transform(1, 0, 0, -1, 0, 500);
        }
        
        for (var categ in this.fruits){
            maxValue = Math.max(maxValue, this.fruits[categ]);
        }

        const canvasActualHeight = this.idPlatna.height - this.padding * 2;

        let gridValue = 0;
        while (gridValue <= maxValue){
            let gridY = canvasActualHeight * (1 - gridValue/maxValue) + this.padding;
            this.drawLine(this.platno, 0, gridY, this.idPlatna.width, gridY, this.gridColor, 0.5);
             
            //writing grid markers
            this.platno.save();
            this.platno.fillStyle = this.gridColor;
            this.platno.font = "bold 10px Arial";
            this.platno.fillText(gridValue, 10, gridY - 2);
            this.platno.restore();
 
            gridValue += this.gridScale;
        }

    }
}

class BarChartPls {
    constructor(_platno, _padding, _width, _height,_arr) {
        this.idPlatna = document.getElementById(_platno);
        this.idPlatna.width = _width;
        this.idPlatna.height = _height;
        this.platno = this.idPlatna.getContext('2d');
        this.padding = _padding;
        this.fruits = {
            Jablka: arr[0],
            Hrušky: arr[1],
            Melouny: arr[2],
            Pomeranče: arr[3],
            Třešně: arr[4]
        }
    }

    barChartOption(platno, upperLeftCornerX, upperLeftCornerY, width, height,color) {
        platno.save();
        platno.fillStyle = color;
        platno.globalAlpha = 0.8;
        platno.fillRect(upperLeftCornerX, upperLeftCornerY, width, height);
        platno.restore();

        platno.strokeStyle = '#FFFFFF';
        platno.lineWidth = 3;
        platno.strokeRect(upperLeftCornerX, upperLeftCornerY, width, height);
    }

    draw() {
        let posunX = 45;
        let zuzeni = 40;
        let maxValue = 0;
        const canvasActualHeight = this.idPlatna.height - this.padding * 2;
        const canvasActualWidth = this.idPlatna.width - this.padding * 2;
        let barIndex = 0;
        const numberOfBars = Object.keys(this.fruits).length;
        const barSize = ((canvasActualWidth-posunX) / numberOfBars)-zuzeni;
        for (var categ in this.fruits) {
            maxValue = Math.max(maxValue, this.fruits[categ]);
        }
        for (categ in this.fruits) {
            const val = this.fruits[categ];
            const barHeight = Math.round((canvasActualHeight * val) / maxValue);
            this.barChartOption(this.platno, this.padding + posunX + barIndex * (barSize+zuzeni),
                this.idPlatna.height - barHeight - this.padding,
                barSize,
                barHeight,
                colors[barIndex]
            );
            barIndex++;
        }
    }
}

class lineChart {
    constructor(_platno, _height, _width) {
        this.idPlatna = document.getElementById(_platno);
        this.platno = this.idPlatna.getContext('2d');
        this.idPlatna.height = _height;
        this.idPlatna.width = _width;
    }
    drawGraph() {
        this.platno.transform(1, 0, 0, -1, 0, 500);
        this.platno.lineWidth = 2;
        this.platno.lineJoin = 'round';
        this.platno.strokeStyle = '#058dc7';
        let maxVal = 0;

        for (let i = 0; i < arrTwo.length; i++) {
            maxVal = Math.max(maxVal, arrTwo[i]);
        }
        /*
        let counter = 5;
        for (let i = 0; i < arrTwo.length; i++) {
            let valu = arrTwo[i];
            let lineHeight = Math.round(((this.idPlatna.height - 10) * valu) / maxVal);
            this.platno.lineTo(counter + 45, lineHeight);
            counter += 100;
        }  */
        this.platno.stroke();
        let counterTwo = 5;  
        for (var i = 0; i < arrTwo.length; i++) {
            let valu = arrTwo[i];
            let lineHeight = Math.round(((this.idPlatna.height - 10) * valu) / maxVal)+2;
            this.platno.beginPath();
            this.platno.arc(counterTwo + 45, lineHeight, 7, 0, Math.PI * 2, true);
            counterTwo += 100;
            this.platno.fillStyle = colorsTwo[i];
            this.platno.closePath();
            this.platno.fill();
        }   
    }
}

class InputVal {
    constructor(_inputs) {
        this.inputs = document.querySelectorAll(_inputs);
        this.truth = true;
    }
    isEqual(data) {
        for (let i = 0; i < data.length; i++) {
            if (this.inputs[i].value == data[i].index) {
                this.inputs[i].style.borderColor = '#15ff00';
            } else {
                this.inputs[i].style.borderColor = 'red';
                this.truth = false;
            }
        }

        if (this.truth) {
            print_modal("modal","ok");
            /*alert('Všechny počty jsi vyplnil správně!')  */
        } else {
            print_modal("modal","neutr",'Díky, ale ještě to není celé dobře. Špatný výběr ovoce jsem označil červeně. Zkus to prosím opravit.');
            /*alert('V některém počtu jsi udělal chybu, máš je označené červenou barvou. Zkus je opravit!')*/
        }
    }
}

class ColorVal extends Table {
    constructor(_nums, _numsTwo, _select, _iconOne, _iconTwo, pole_objektu) {
        super(_nums, _numsTwo);
        this.select = document.querySelectorAll(_select);
        this.iconOne = document.querySelectorAll(_iconOne);
        this.iconTwo = document.querySelectorAll(_iconTwo);
        this.rows = document.querySelectorAll(_nums);
        this.truth = true;
        this.pole_objektu = pole_objektu;
    }     

    selectId(spec,arrX) {
        this.array_id = [0, 1, 2, 3, 4];
        if(spec == "two"){
            var bunkyBarev = document.getElementsByClassName("barvy");
            var tplSpatnaCisla = [];
            for (let i = 0; i < this.pole_objektu.length; i++){
                tplSpatnaCisla.push(this.pole_objektu[i].pocet);    
            }
            let tplRandom = 0;
            for (let x = 0; x < 3; x++) {
                tplRandom = (Math.floor(Math.random() * 45) + 1) * 4;
                if (!tplSpatnaCisla.includes(tplRandom))
                    tplSpatnaCisla.push(tplRandom);
                else x--;
            }
            tplSpatnaCisla = tplSpatnaCisla.sort(function (a, b) { return a - b });      //serazeni
        }                
        Table.shuffleArray(this.array_id);
        for (let i = 0; i < 5; i++) {
            if(spec == "one")
                this.select[i].setAttribute('id', this.array_id[i] + spec);
            else{
                let vzor = document.createElement('span');
                vzor.style.backgroundColor = this.pole_objektu[this.array_id[i]].barva;
                vzor.classList.add("vzorSpan");
                bunkyBarev[i].appendChild(vzor);
            }                  
            this.rows[i].setAttribute('id', 'id_' + this.array_id[i] + spec);
            this.iconOne[i].setAttribute('id', 'iconOne' + this.array_id[i] + spec);
            this.iconTwo[i].setAttribute('id', 'iconTwo' + this.array_id[i] + spec);                              
        }
        let pomArr = [0,0,0,0,0];
        for (let i = 0; i < this.pole_objektu.length; i++) {
            if(spec == "one")
                document.getElementById('id_' + i + spec).innerHTML = this.pole_objektu[i].pocet;
            else{
                let tplRodic = document.getElementById('id_' + i + spec);                 
                tplRodic.innerHTML = "";
                let select = document.createElement("select");
                select.setAttribute("id",i + spec);
                select.classList.add("numerTwo","cap5");
                //skryvajici se option
                let option = document.createElement("option");
                option.hidden = option.selected = option.disabled = true;
                option.innerHTML = "?"; option.value = -1;
                select.appendChild(option);
                //TODO: select musi mit listener
                Table.kontrolujInputy(select, "cisla");
                for (let x = 0; x < tplSpatnaCisla.length;x++){  //8
                    option = document.createElement('option');
                    option.value = tplSpatnaCisla[x];
                    option.innerHTML = tplSpatnaCisla[x];
                    select.appendChild(option);
                }                
               tplRodic.appendChild(select);
            }
            pomArr[i] = this.pole_objektu[this.array_id[i]].pocet;
        }
        
        for(let i=0; i<5; i++){
            this.pole_objektu[i].index = pomArr.indexOf(arrX[i]);
        }
    }

    isEqual(spec) {
        this.truth = true;
        if(spec == "one")          //vyber barvy
          for (let i = 0; i < this.pole_objektu.length; i++) {
              if (
                  document.getElementById(i + spec).value == this.pole_objektu[i].barva
              ) {
                  //console.log(this.pole_objektu[i].barva)
                  document.getElementById('iconTwo' + i + spec).style.display = 'none';
                  document.getElementById('iconOne' + i + spec).style.display = 'block';
              } else {
                  document.getElementById('iconOne' + i + spec).style.display = 'none';
                  document.getElementById('iconTwo' + i + spec).style.display = 'block';
                  this.truth = false;
              }
          }
        else                   //vyber poctu
            for (let i = 0; i < this.pole_objektu.length; i++) {
              if (
                  document.getElementById(i + spec).value == this.pole_objektu[i].pocet
              ) {
                  //console.log(this.pole_objektu[i].barva)
                  document.getElementById('iconTwo' + i + spec).style.display = 'none';
                  document.getElementById('iconOne' + i + spec).style.display = 'block';
              } else {
                  document.getElementById('iconOne' + i + spec).style.display = 'none';
                  document.getElementById('iconTwo' + i + spec).style.display = 'block';
                  this.truth = false;
              }
          }

        if (this.truth) {
            print_modal("modal","ok");
            /*alert('Všechny barvy jsi vyplnil správně!') */
        } else {
            let stringX = "";
            if(spec == "one")   stringX = "některé barvě";
            else                stringX = "některém počtu";
            print_modal("modal","neutr",'Díky, ale ještě to není celé dobře. V '+stringX+' jsi udělal chybu, máš to označené červeným krížkem. Zkus to prosím opravit.');
            /*alert('V některé barvě jsi udělal chybu, máš ji označenou červeným krížkem. Zkus je opravit!')*/
        }
    }
}

class start {
    constructor() {}
    static madeTable() {
        const newGame = document.querySelector('#newGame_pr5');
        const btnOne = document.querySelector('#btnOne');
        const btnTwo = document.querySelector('#btnTwo');
        const tabOne = document.querySelector('#tabOne');
        const tabTwo = document.querySelector('#tabTwo');
        const tab = new Table('.nums', '.numsTwo');
        tab.addNums();
        //Table.shuffleArray(arr);
        Table.shuffleArray(colors);
        Table.shuffleArray(colorsTwo);
        //Table.shuffleArray(arrTwo);
        let pole_objektu1 = [
            { pocet: arr[0], barva: colors[0], index: 0 },
            { pocet: arr[1], barva: colors[1], index: 1 },
            { pocet: arr[2], barva: colors[2], index: 2 },
            { pocet: arr[3], barva: colors[3], index: 3 },
            { pocet: arr[4], barva: colors[4], index: 4 }
        ];
        let pole_objektu2 = [
            { pocet: arrTwo[0], barva: colorsTwo[0], index: 0 },
            { pocet: arrTwo[1], barva: colorsTwo[1], index: 1 },
            { pocet: arrTwo[2], barva: colorsTwo[2], index: 2 },
            { pocet: arrTwo[3], barva: colorsTwo[3], index: 3 },
            { pocet: arrTwo[4], barva: colorsTwo[4], index: 4 }
        ];

        const colorsInp = new ColorVal('.nums', '.numsTwo', '.colorOne', '.oneCheck', '.oneCross', pole_objektu1);
        colorsInp.selectId('one',arr);

        btnOne.addEventListener('click', function() {
            const inputsChart = new InputVal('.barInputs'); 
            inputsChart.isEqual(pole_objektu1);
        });
        tabOne.addEventListener('click', function() {
            colorsInp.isEqual('one');
        });
        
        const barChartTry = new BarChartPls('barChart', 0, 500, 500);
        const gridViewOne = new grid("barChart", 500, 500, "gray", 10, 0, arr);
        gridViewOne.drawGrid();
        barChartTry.draw();

        const colorsInpTwo = new ColorVal('.numsTwo', '.numsTwo', '.colorTwo', '.twoCheck', '.twoCross', pole_objektu2);
        colorsInpTwo.selectId('two',arrTwo);
        // -> kontrolujInputy();
        btnTwo.addEventListener('click', function() {
            const inputsChart = new InputVal('.lineInputs');
            inputsChart.isEqual(pole_objektu2);
        });
        btnTwo.style.display = "none";
        tabTwo.addEventListener('click', function() {
            colorsInpTwo.isEqual('two');
        });
        tabTwo.style.display = "none";
        
        const line = new lineChart('lineChart', 500, 500);
        const gridViewTwo = new grid("lineChart", 500, 500, "gray", 10, 0, arrTwo);
        line.drawGraph();
        gridViewTwo.drawGrid("JO");
        
        /*vytvorim selecty pro ovoce */
        let obal = document.getElementById('barOvoce');
        let obalI = document.getElementById('lineOvoce');
        let select, option;
        //1. priklad
        for(let i=0;i<5;i++){
            select = document.createElement('select');
            select.classList.add("barInputs","w3-col","l2","m2","s2");
            for(let x=0;x<5;x++){
                option = document.createElement('option');
                option.value = x;
                option.innerHTML = ovoce[x];
                select.appendChild(option);
            }
            obal.appendChild(select);
        }
        //2. priklad
        for(let i=0;i<5;i++){
            select = document.createElement('select');
            select.classList.add("lineInputs","w3-col","l2","m2","s2");
            let tplPole = [];
            let tplOvoce;
            for(let x=0;x<8;x++){   //5 + 3 (3 spatne volby) - tady to nepromicham tak snadno - priprava dat
                tplOvoce = [];
                tplOvoce[0] = x;
                tplOvoce[1] = ovoce[x];
                tplPole.push(tplOvoce);
            }
            tplPole = tplPole.sort(function (a, b) { return 0.5 - Math.random() });
            //skryvajici se option 
            option = document.createElement("option");
            option.hidden = option.selected = option.disabled = true; 
            option.innerHTML = "?"; option.value = -1;
            select.appendChild(option);
            //TODO: select musi mit listener
            Table.kontrolujInputy(select, "veci");
            //option na vyber
            for (let x = 0; x < 8; x++) {   // vkladani
                option = document.createElement('option');
                option.value = tplPole[x][0];
                option.innerHTML = tplPole[x][1];
                select.appendChild(option);
            }
            obalI.appendChild(select);
        }         
    }       
}

window.addEventListener('load', function() {
    start.madeTable();
})